/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   matrix_routine.c                                   :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/16 18:20:31 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/16 19:00:22 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

void		recalculate_trnsf_matrs(t_map *map)
{
	mat4_x_rot(map->trnsf->xr, INIT_X + map->x_rot);
	mat4_z_rot(map->trnsf->zr, INIT_Z + map->z_rot);
	mat4_y_rot(map->trnsf->yr, INIT_Y + map->y_rot);
	mat4_scale(map->trnsf->sc,
			INIT_X_SCALE * map->scale[0],
			INIT_Y_SCALE * map->scale[1],
			INIT_Z_SCALE * map->scale[2]);
}
//
//static void	viewport_projection_translate(t_trnsf *tf)
//{
//	t_mat4 *tmp;
//
//	tmp = tf->vp_pr_tr;
//	tf->vp_pr_tr = mat4_mult(tf->vp, tf->pr);
//	free(tmp);
//	tmp = tf->vp_pr_tr;
//	tf->vp_pr_tr = mat4_mult(tf->tr, tf->vp_pr_tr);
//	free(tmp);
//}

//void		initial_trnsf_mats(t_fdf *fdf)
//{
//	t_trnsf	*tf;
//
//	tf = trnsf_mat_init();
//	tf->vp = viewport_mat_init(fdf->w_width, fdf->w_height);
//	tf->pr = orth_mat_init(
//			(fdf->map->y_max > fdf->map->x_max) ? fdf->map->y_max :
//			fdf->map->x_max + 2,
//			(fdf->map->y_max > fdf->map->x_max) ? fdf->map->y_max :
//			fdf->map->x_max + 2,
//			fdf->map->z_max + 2);
//	mat4_translate(
//			tf->tr,
//			(float)((fdf->map->y_max > fdf->map->x_max) ?
//					fdf->map->y_max : fdf->map->x_max) / 2.0f,
//			(float)((fdf->map->y_max > fdf->map->x_max) ?
//					fdf->map->y_max : fdf->map->x_max) / 2.0f,
//			(float)fdf->map->z_max / 2.0f);
//	mat4_x_rot(tf->xr, INIT_X);
//	mat4_z_rot(tf->zr, INIT_Z);
//	mat4_y_rot(tf->yr, INIT_Y);
//	mat4_scale(tf->sc, INIT_X_SCALE, INIT_Y_SCALE, INIT_Z_SCALE);
//	viewport_projection_translate(tf);
//	fdf->map->trnsf = tf;
//}

void		mat4_mult_chain(t_trnsf *tf)
{
	t_mat4		*tmp;

	tmp = tf->fin;
	tf->fin = mat4_mult(tf->zr, tf->vp_pr_tr);
	free(tmp);
	tmp = tf->fin;
	tf->fin = mat4_mult(tf->xr, tf->fin);
	free(tmp);
	tmp = tf->fin;
	tf->fin = mat4_mult(tf->yr, tf->fin);
	free(tmp);
	tmp = tf->fin;
	tf->fin = mat4_mult(tf->sc, tf->fin);
	free(tmp);
}
